local AddonName,T = ... --in jede Datei
local L = T["local"]	--in jede Datei, die die Lokalisierung braucht
local Q = T["quests"]	--in jede Datei, die die Questnamen braucht
local D = T["data"]		--in jede Datei, die die Daten braucht

local WHUT_DEBUG = {}
WHUT_DEBUG["Listen"]=false --enables the debug-output for online/server/user-list
WHUT_DEBUG["Chat"]=true --enables the debug-output for Chatmessages and communication
WHUT_DEBUG["Roster"]=false --enables the debug-output for Raid/Guild-Updates
WHUT_DEBUG["GUI"]=false --enables the debug-output for GUI
WHUT_DEBUG["Data"]=false --enables the debug-output for Data-Management
WHUT_VERSION = 0100

--Strings used for Data-Storing
local WHUT_ONLINE = "online"
local WHUT_SERVER = "server"
local WHUT_USER = "user"
local WHUT_QUEST = "quest"
local WHUT_FONT = "Fonts\\FRIZQT__.TTF"
local WHUT_FONTSIZE = 11
local WHUT_FONTFLAG = "OUTLINE, MONOCHROME"

--Data-Storing
WHUT_user = {}
WHUT_user[WHUT_ONLINE] = {}
WHUT_user[WHUT_SERVER] = {}
WHUT_user[WHUT_USER] = {}
WHUT_data = {}
WHUT_data[WHUT_QUEST] = {}
WHUT_save = {}

--local Variables
local numberOfServers = 2
local actAsServer = false
local playerName = UnitName("player");
local raidUpdate = 0
local serverUpdate = 0
local onlineSince = 0
local timeSinceLastUpdate = 0
local timeSinceLastSync = 0
local init = false
local WHUT_UpdateInterval = 1.0; -- How often the OnUpdate code will run (in seconds)
local WHUT_SyncInterval = 60;


--frames & Events
RegisterAddonMessagePrefix("WHUT")

local frame = CreateFrame("Frame","WHUT_frame",UIParent)
frame:RegisterEvent("CHAT_MSG_ADDON")
frame:RegisterEvent("RAID_ROSTER_UPDATE")
frame:RegisterEvent("PARTY_MEMBERS_CHANGED")
frame:RegisterEvent("PLAYER_ENTERING_WORLD")
frame:RegisterEvent("PLAYER_LEAVING_WORLD")
frame:RegisterEvent("PLAYER_TARGET_CHANGED")
frame:RegisterEvent("VARIABLES_LOADED")
frame:RegisterEvent("QUEST_ACCEPTED")
frame:RegisterEvent("QUEST_DETAIL")
frame:RegisterEvent("GOSSIP_SHOW")
frame:SetSize(100,50)
frame:SetFrameStrata("BACKGROUND")
frame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", 
                                            edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
                                            tile = true, tileSize = 16, edgeSize = 16, 
                                            insets = { left = 4, right = 4, top = 4, bottom = 4 }});
frame:SetBackdropColor(0,0,0,0.5)
frame:SetPoint("TOPLEFT",UIParent,"CENTER")
frame:SetMovable(true)
frame:EnableMouse(true)
frame:RegisterForDrag("LeftButton")
frame:SetScript("OnDragStart", frame.StartMoving)
frame:SetScript("OnDragStop", frame.StopMovingOrSizing)
frame:Show()

frame.clients = CreateFrame("Frame",nil,frame)
frame.clients:Show()
frame.clients.names = {}
frame.clients.fonts = {}

frame.data = CreateFrame("Frame", "WHUT_framedata", frame, "QuestGroupTemplate")
frame.data.expandedHeight = 50
frame.data:Show()
frame.data.quests = {}
frame.data.fonts = {}
--[[
testframe = CreateFrame("Frame", nil, frame, "QuestGroupTemplate")
testframe:SetSize(10,10)
testframe:SetPoint("TOPRIGHT", frame, "TOPLEFT")
testframe.NameText:SetText("blubb");
--testframe.Content.Stat1.Label:SetText("blah")
--testframe.Content.Stat1.Value:SetText("blaaah")
--testframe.Content.Stat2.Label:SetText("blahh")
--testframe.Content.Stat2.Value:SetText("blaaahh")
--testframe.Content.Stat2:SetPoint("TOPLEFT", testframe.Stat1, "BOTTOMLEFT")

testframe.collapsed = true;
testframe.expandedHeight = 180

testframe.CollapsedIcon:Show(); -- (+)
testframe.ExpandedIcon:Hide(); -- (-)
testframe:SetHeight(18);
testframe.BgMinimized:Show(); --Kompletter Hintergrund collapsed
testframe.BgTop:Hide(); -- Hintergrund obere Hälfte Überschrift
testframe.BgMiddle:Show(); --leer
testframe.BgBottom:Show(); --untere Hälfte Hintergrund, ca 3-4 zeilen
testframe.Content:Show()
testframe.BgBottom:SetHeight(18)
]]

  

-------------------------------------------------------------------------
-----------------------------Addon-functions-----------------------------
-------------------------------------------------------------------------
--adds a User to one of the lists
local function AddUser(name, list)
	if(WHUT_DEBUG["Listen"]) then DEFAULT_CHAT_FRAME:AddMessage("füge hinzu in Liste "..list..": "..name) end
	if (list==nil or name==nil) then return end
	WHUT_user[list][name]=1
end

--removes a User from one of the lists
local function RemoveUser(name, list)
	if(WHUT_DEBUG["Listen"]) then DEFAULT_CHAT_FRAME:AddMessage("entferne von Liste "..list..": "..tostring(name)) end
	WHUT_user[list][name]=nil
end

local function SizeOf(list)
	local number = 0
	
	for k,v in pairs(list) do
		number=number+1
	end
	
	return number
end

--sends all Users on the Online-List to name
local function SendOnline(name)
	WHUT_user[WHUT_ONLINE][name]=time()
	for k,v in pairs(WHUT_user[WHUT_ONLINE]) do
		SendAddonMessage("WHUT", "O:"..k, "WHISPER", name)
	end
end

--sends all Users on the Server-List to name
local function SendServer(name)
	WHUT_user[WHUT_ONLINE][name]=time()
	for k,v in pairs(WHUT_user[WHUT_SERVER]) do
		SendAddonMessage("WHUT", "S:"..k, "WHISPER", name)
	end
	if (actAsServer) then
		SendAddonMessage("WHUT", "S:"..playerName, "WHISPER", name)
	end
end

local function GetNumActiveQuests(data)
	local active=0
	if (not data) then return end
	
	
	for key,value in pairs(data) do
	if type(key)=="number" then
		if (type(value)=="number") then
			--Quest aktiv?
			if WHUT_data[WHUT_QUEST][value] then
				active = active + 1
			end
		elseif (type(value)=="table") then
			--Untergruppen auflisten
			active = active + GetNumActiveQuests(value)
		end
	end
	end
	
	return active
end

local function GetQuestPossible(data, questid)
	if (not data) then return end
	
	--Gruppe voll: durchsuchen unnötig
	if(data["max"]) then
	if (GetNumActiveQuests(data)>=data["max"]) then
		return false
	end
	end
	
	possible = false
	
	for key,value in pairs(data) do
	if type(key)=="number" then
		if (type(value)=="number") then
			--Quest in dieser Gruppe?
			if (value==questid)then
				return true
			end
		elseif (type(value)=="table") then
			--Untergruppen durchsuchen
			if GetQuestPossible(value, questid)==true then
				return true
			end
		end
	end
	end
	
	--Quest nicht gefunden
	return false
end

local function GetQuestStatus(questid)
	if (WHUT_data[WHUT_QUEST][questid])	then
		return 0,1,0
	elseif (GetQuestPossible(D["Quests"],questid)==false) then
		return 1,0,0
	else
		return 1,1,1
	end
end

local function CheckValid()
	if (not WHUT_data[WHUT_QUEST]["valid"]) then
		WHUT_data[WHUT_QUEST]["valid"]=0
	end
	if (WHUT_data[WHUT_QUEST]["valid"] < time()+60) then --60 sec safety-time before real reset, to avoid sync-errors
		WHUT_data[WHUT_QUEST]={}
		WHUT_data[WHUT_QUEST]["valid"] = time()+GetQuestResetTime()
	end	
end

local function AddData(number)
	CheckValid()
	WHUT_data[WHUT_QUEST][tonumber(number)]=true
	if(WHUT_DEBUG["Data"]) then DEFAULT_CHAT_FRAME:AddMessage(number..": true") end
	WHUT_data[WHUT_QUEST]["valid"]=time()+GetQuestResetTime()
end

local function SendData(name)
	CheckValid()
	for k,v in pairs(WHUT_data[WHUT_QUEST]) do
		if (type(k)=="number") then
			WHUT_user[WHUT_ONLINE][name]=time()
			SendAddonMessage("WHUT", "Q:"..k, "WHISPER", name)
		end
	end
end

local function SaveData()
	if(not init) then return end
	if(not WHUT_save[GetRealmName()]) then
		WHUT_save[GetRealmName()]={}
	end
	WHUT_save[GetRealmName()][WHUT_USER]=WHUT_user[WHUT_USER]
	WHUT_save[GetRealmName()][WHUT_QUEST]=WHUT_data[WHUT_QUEST]
end

--tell the other servers that i am a server now and wait for their Data
local function BecomeServer()
	actAsServer=true
	serverUpdate=time()
	for k,v in pairs(WHUT_user[WHUT_SERVER]) do
		WHUT_user[WHUT_ONLINE][k]=time()
		SendAddonMessage("WHUT", "S:"..playerName, "WHISPER", k)
	end
end

--Filter-Function for Offline-Messages
local function filterOfflineMessages(self, event, msg, author,...)
	local str = _G["ERR_CHAT_PLAYER_NOT_FOUND_S"]:gsub("%%s", ".+")
	if msg:match(str) then 
		local pre,post = strsplit("+", (_G["ERR_CHAT_PLAYER_NOT_FOUND_S"]:gsub("%%s", "+")))
		local name = msg:gsub(pre, ""):gsub(post,"")
		if(WHUT_user[WHUT_ONLINE][name]) then
		  if ((WHUT_user[WHUT_ONLINE][name]+10)>time()) then
			WHUT_user[WHUT_ONLINE][name]=nil
			WHUT_user[WHUT_SERVER][name]=nil
			return true
		  end
		end
	end
end

-------------------------------------------------------------------------
------------------------------GUI-functions------------------------------
-------------------------------------------------------------------------

local function UpdateUserList()
	if(WHUT_DEBUG["GUI"]) then DEFAULT_CHAT_FRAME:AddMessage("Updating GUI") end
	local lastFont
	local height = 0
	local width = 0
	
	--alte Liste unsichtbar machen
	for k,v in pairs(frame.clients.names) do
		frame.clients.names[k]:SetPoint("TOPLEFT",frame.clients,"TOPLEFT")
		frame.clients.names[k]:Hide()
	end
	
	--Eigene Rolle
	if(type(frame.clients.fonts["myRole"])~="table") then
		if(WHUT_DEBUG["GUI"]) then DEFAULT_CHAT_FRAME:AddMessage("Create Server String") end
		frame.clients.fonts["myRole"] = frame.clients:CreateFontString("actAsServer")
		frame.clients.fonts["myRole"]:SetFont("Fonts\\FRIZQT__.TTF", 11, "OUTLINE, MONOCHROME")
	end	
	if (actAsServer == true) then
		frame.clients.fonts["myRole"]:SetText(string.format(L["I'm a %s"],"|cFFFF0000"..L["SERVER"]))
	elseif (actAsServer == false) then
		frame.clients.fonts["myRole"]:SetText(string.format(L["I'm a %s"],"|cFF00FF00"..L["Client"]))
	end
	frame.clients.fonts["myRole"]:SetPoint("TOPLEFT",frame.clients,"TOPLEFT")
	height = height + frame.clients.fonts["myRole"]:GetHeight()
	width = math.max(width,frame.clients.fonts["myRole"]:GetWidth())
	lastFont = frame.clients.fonts["myRole"]
	
	--Überschrift Serverliste
	if(type(frame.clients.fonts["Server"])~="table") then
		if(WHUT_DEBUG["GUI"]) then DEFAULT_CHAT_FRAME:AddMessage("Create Server_Heading String") end
		frame.clients.fonts["Server"] = frame.clients:CreateFontString("ServerHeading")
		frame.clients.fonts["Server"]:SetFont("Fonts\\FRIZQT__.TTF", 11, "OUTLINE, MONOCHROME")
		frame.clients.fonts["Server"]:SetText(L["Serverlist:"])
	end	
	frame.clients.fonts["Server"]:SetPoint("TOPLEFT",lastFont,"BOTTOMLEFT")
	height = height + frame.clients.fonts["Server"]:GetHeight()
	width = math.max(width,frame.clients.fonts["Server"]:GetWidth())
	lastFont = frame.clients.fonts["Server"]
	
	
	--ServerListe
	for k,v in pairs(WHUT_user[WHUT_SERVER]) do
		if(type(frame.clients.names[k])~="table") then
			if(WHUT_DEBUG["GUI"]) then DEFAULT_CHAT_FRAME:AddMessage("Create "..k.." String") end
			frame.clients.names[k]=frame.clients:CreateFontString(k)
			frame.clients.names[k]:SetFont("Fonts\\FRIZQT__.TTF", 11, "OUTLINE, MONOCHROME")
			frame.clients.names[k]:SetText(k)
		end
		frame.clients.names[k]:SetTextColor(1,0,0)
		frame.clients.names[k]:SetPoint("TOPLEFT",lastFont,"BOTTOMLEFT")
		frame.clients.names[k]:Show()
		height = height + frame.clients.names[k]:GetHeight()
		width = math.max(width,frame.clients.names[k]:GetWidth())
		lastFont = frame.clients.names[k]
	end
	
	--Überschrift Onlineliste
	if(type(frame.clients.fonts["Online"])~="table") then
		if(WHUT_DEBUG["GUI"]) then DEFAULT_CHAT_FRAME:AddMessage("Create Client_Heading String") end
		frame.clients.fonts["Online"] = frame.clients:CreateFontString("OnlineHeading")
		frame.clients.fonts["Online"]:SetFont("Fonts\\FRIZQT__.TTF", 11, "OUTLINE, MONOCHROME")
		frame.clients.fonts["Online"]:SetText(L["Clientlist:"])
	end	
	frame.clients.fonts["Online"]:SetPoint("TOPLEFT",lastFont,"BOTTOMLEFT")
	height = height + frame.clients.fonts["Online"]:GetHeight()
	width = math.max(width,frame.clients.fonts["Online"]:GetWidth())
	lastFont = frame.clients.fonts["Online"]
	
	
	--OnlineListe
	for k,v in pairs(WHUT_user[WHUT_ONLINE]) do
	if(not WHUT_user[WHUT_SERVER][k]) then
		if(type(frame.clients.names[k])~="table") then
			if(WHUT_DEBUG["GUI"]) then DEFAULT_CHAT_FRAME:AddMessage("Create "..k.." String") end
			frame.clients.names[k]=frame.clients:CreateFontString(k)
			frame.clients.names[k]:SetFont("Fonts\\FRIZQT__.TTF", 11, "OUTLINE, MONOCHROME")
			frame.clients.names[k]:SetText(k)
		end
		frame.clients.names[k]:SetTextColor(0,1,0)
		frame.clients.names[k]:SetPoint("TOPLEFT",lastFont,"BOTTOMLEFT")
		frame.clients.names[k]:Show()
		height = height + frame.clients.names[k]:GetHeight()
		width = math.max(width,frame.clients.names[k]:GetWidth())
		lastFont = frame.clients.names[k]
	end
	end
	
	frame.clients:SetHeight(height)
	frame.clients:SetWidth(width)
end

local function CollapseQuestGroup()
end
local function ExpandQuestGroup(groupframe)
	groupframe.collapsed = false;
	groupframe.CollapsedIcon:Hide();
	groupframe.ExpandedIcon:Show();
	groupframe.Content:Show()
	groupframe:SetHeight(22+groupframe.Content:GetHeight())
	groupframe.BgMinimized:Hide();
	groupframe.BgTop:Show();
	groupframe.BgMiddle:Show();
	groupframe.BgBottom:Show();
end


--[[
H: Header
Q: Quest
F: Frame (i.e. the subgroup under a Header)
h: horizontal
v: vertical
]]--
local SPACE = {
	["H"]={
		["h"]=0,
		["v"]=0
		},
	["Q"]={
		["h"]=5,
		["v"]=0
		},
	["F"]={
		["h"]=10,
		["v"]=0
		},
	}
local function UpdateData(data, parent)	
	local i=1
	if (not data) then return end
	--parent.Content:SetWidth(0)
	parent.Content:SetHeight(0)
	
	
	for key,value in pairs(data) do
	if type(key)=="number" then
		if (type(value)=="number") then
			--Quest darstellen
			
			local v=value
			if(type(parent[i])~="table") then
				parent[i] = parent.Content:CreateFontString()
				parent[i]:SetFont(WHUT_FONT, WHUT_FONTSIZE, WHUT_FONTFLAG)
			end
			parent[i]:SetText(Q[v])
			parent[i]:SetTextColor(GetQuestStatus(v))
			
			parent[i]:ClearAllPoints()
			if (i==1) then
				parent[i]:SetPoint("TOP", parent.Content, "TOP",0,-SPACE.Q.v)
			else
				parent[i]:SetPoint("TOP", parent[i-1], "BOTTOM",0,-SPACE.Q.v)
			end
			
			parent[i]:SetPoint("LEFT", parent.Content, "LEFT", SPACE.Q.h,0)
			parent.Content:SetWidth(math.max(parent.Content:GetWidth(),parent[i]:GetWidth()+SPACE.Q.h))
			parent.Content:SetHeight(parent.Content:GetHeight()+parent[i]:GetHeight()+SPACE.Q.v)
			i = i + 1
			
		elseif (type(value)=="table") then
		
				--Frame erzeugen
				if(type(parent[i])~="table") then
					parent[i] = CreateFrame("Frame",parent:GetName().."-"..i,parent.Content,"QuestGroupTemplate")
				end
				
				parent[i]:ClearAllPoints()

				local head = ""
				if(value["name"]) then
					head=value["name"]
				end
				if(value["max"])then
					head = head.." - ("
					local active = GetNumActiveQuests(value)
					if active~=0 then
						head=head..active.."/"
					end
					head=head..value["max"]..")"
				end
				parent[i].NameText:SetText(head)
				parent[i].Content:SetWidth(parent[i].NameText:GetWidth()+parent[i].CollapsedIcon:GetWidth()+10)
				parent[i].Content:SetHeight(0)
				
				
				
				if (i==1) then
					parent[i]:SetPoint("TOP", parent.Content, "TOP",0,-SPACE.F.v)
				else
					parent[i]:SetPoint("TOP", parent[i-1], "BOTTOM",0,-SPACE.F.v)
				end
				
				parent[i]:SetPoint("LEFT", parent.Content, "LEFT", SPACE.F.h,0)
				
				--Untergruppen auflisten
				UpdateData(value,parent[i])
				
				
				if (parent[i].collapsed) then
				else
					ExpandQuestGroup(parent[i])
				end
				
				parent.Content:SetWidth(math.max(parent.Content:GetWidth(),parent[i]:GetWidth()+SPACE.F.h))
				parent.Content:SetHeight(parent.Content:GetHeight()+parent[i]:GetHeight()+SPACE.F.v)
				
				parent[i].BgTop:SetSize(parent[i].Content:GetWidth(),9)
				parent[i].BgMiddle:SetWidth(parent[i].Content:GetWidth())
				parent[i].BgBottom:SetSize(parent[i].Content:GetWidth(),9)
				parent[i].BgMinimized:SetWidth(parent[i].Content:GetWidth())
				i = i + 1
			end
		end
	end
	
	parent:SetWidth(parent.Content:GetWidth())
	if parent.collapsed then
		parent:SetHeight(22)
	else
		parent:SetHeight(22+parent.Content:GetHeight())
	end
end

local function clearAnchors(frame)
	for k,v in ipairs(frame) do
		clearAnchors(v)
	end
	frame:ClearAllPoints()
end

local function UpdateGui()
	if (not frame.clients:IsShown() and not frame.data:IsShown()) then
		frame:Hide()
		return
	end
		
	local height = 0
	local width = 10	
		
	if (frame.clients:IsShown()) then
		UpdateUserList()
		frame.clients:SetPoint("TOPLEFT",frame,"TOPLEFT",10,-10)
		height = frame.clients:GetHeight()
		width = width + frame.clients:GetWidth() + 10
	end
	if (frame.data:IsShown()) then
		clearAnchors(frame.data)
		UpdateData(D["Quests"],frame.data)
		--Grafik auf richtige Größe
		frame.data.NameText:SetText("Quests")
		frame.data.BgTop:SetSize(frame.data.Content:GetWidth(),9)
		frame.data.BgMiddle:SetWidth(frame.data.Content:GetWidth())
		frame.data.BgBottom:SetSize(frame.data.Content:GetWidth(),9)
		frame.data.BgMinimized:SetWidth(frame.data.Content:GetWidth())
		--Dimensionen für frame bestimmen
		height = math.max(height, frame.data:GetHeight())
		width = width + frame.data:GetWidth() + 10
		if (frame.clients:IsShown()) then
			frame.data:SetPoint("TOPLEFT",frame.clients,"TOPRIGHT",10,0)
		else
			frame.data:SetPoint("TOPLEFT",frame,"TOPLEFT",10,-10)
		end
	end
	
	
	frame:SetWidth(width)
	frame:SetHeight(height+20)
end
-------------------------------------------------------------------------
-----------------------------Event-functions-----------------------------
-------------------------------------------------------------------------

SLASH_WHUT1 = "/whatsuptoday"
SLASH_WHUT2 = "/whut"
SlashCmdList["WHUT"] = function(cmd) 
	if(not cmd or string.len(cmd)==0) then
		--Slashkommande ohne Optionen
		DEFAULT_CHAT_FRAME:AddMessage("WhatsUpToday-Slashkommandos:")
		DEFAULT_CHAT_FRAME:AddMessage("/whut showuser/hideuser - Blendet die Nutzerliste ein/aus")
		DEFAULT_CHAT_FRAME:AddMessage("/whut showdata/hidedata - Blendet die Questliste ein/aus")
		DEFAULT_CHAT_FRAME:AddMessage("/whut update - Aktualisiert die Daten")
		DEFAULT_CHAT_FRAME:AddMessage("/whut add <online/server/user> Name - Fügt einen Nutzer einer Liste hinzu")
		DEFAULT_CHAT_FRAME:AddMessage("/whut list <online/server/user> Name- Zeigt eine Liste an")
		DEFAULT_CHAT_FRAME:AddMessage("/whut remove <online/server/user> Name- Entfernt einen Nutzer von einer Liste")
		DEFAULT_CHAT_FRAME:AddMessage("/whut request <online/server> Name- Fragt einen Nutzer nach seiner Liste")
		DEFAULT_CHAT_FRAME:AddMessage("/whut update - Fragt alle Nutzer nach allen Listen")
		DEFAULT_CHAT_FRAME:AddMessage("/whut addquest #### - Setzt eine Quest als verfügbar")
	else
	--Optionen
	
		local split1, split2, cmd = strsplit(" ",cmd,3)
		--online/server/users
		local list = "";
		if (split2=="online") then
			list = WHUT_ONLINE
		elseif (split2=="server") then
			list = WHUT_SERVER
		elseif (split2=="user") then
			list = WHUT_USER
		end
		
		--add/list/remove
		if(split1 == "add") then
			AddUser(tostring(cmd), list)
		elseif(split1 == "list") then
			for k,v in pairs(WHUT_user[list]) do
				DEFAULT_CHAT_FRAME:AddMessage("Online: "..tostring(k)..tostring(v))
			end
		elseif(split1 == "remove") then
			RemoveUser(tostring(cmd),list)
		elseif(split1 == "request") then
			DEFAULT_CHAT_FRAME:AddMessage("Request "..list.."-List from "..cmd)
			if (list=="online") then
				WHUT_user[WHUT_ONLINE][cmd]=time()
				SendAddonMessage("WHUT", "RO", "WHISPER", cmd)
			elseif (list=="server") then
				WHUT_user[WHUT_ONLINE][cmd]=time()
				SendAddonMessage("WHUT", "RS", "WHISPER", cmd)
			end
		elseif(split1 == "update") then
			SendAddonMessage("WHUT", "RS", "GUILD")
			SendAddonMessage("WHUT", "RO", "GUILD")
			SendAddonMessage("WHUT", "RS", "RAID")
			SendAddonMessage("WHUT", "RO", "RAID")
			for k,v in pairs(WHUT_user[WHUT_SERVER]) do
				WHUT_user[WHUT_ONLINE][k]=time()
				SendAddonMessage("WHUT", "RS", "WHISPER", k)
				SendAddonMessage("WHUT", "RO", "WHISPER", k)
			end
		elseif(split1 == "showuser") then
			frame:Show()
			frame.clients:Show()
			UpdateGui()
		elseif(split1 == "showdata") then
			frame:Show()
			frame.data:Show()
			UpdateGui()
		elseif(split1 == "hideuser") then
			frame.clients:Hide()
			UpdateGui()
		elseif(split1 == "hidedata") then
			frame.data:Hide()
			UpdateGui()
		elseif(split1 == "addquest") then
			AddData(split2)
		end
		
	end
end

local function WHUT_OnEvent(self,event,...)
	if(event=="CHAT_MSG_ADDON") then
		if (WHUT_DEBUG["Chat"]) then
			DEFAULT_CHAT_FRAME:AddMessage("CHAT_MSG_ADDON")
		end
		--Handle Addon Messages
		--Messages:
		--"RS" - requesting server List
		--"RO" - requesting online List
		--"RD" - requesting Data
		--"RC" - requesting Online-Check (to be respondet with "O:ownName", so Addon can check that ownName==sender)
		--"UL" - User leaving
		--"S:Name" - Name is a Server
		--"O:Name" - Name is online
		--"Q:####" - Quest with Number is active today
		--"N:####" - NPC with Number is active today
		--"H:####" - Hash to Check Data-Sync

		local prefix, message, channel, sender = ...;
		
		if (not prefix=="WHUT") then return end
		
		if (WHUT_DEBUG["Chat"]) then
			DEFAULT_CHAT_FRAME:AddMessage("Addon-Message erhalten!")
			DEFAULT_CHAT_FRAME:AddMessage("prefix: "..prefix)
			DEFAULT_CHAT_FRAME:AddMessage("message: "..message)
			DEFAULT_CHAT_FRAME:AddMessage("channel: "..channel)
			DEFAULT_CHAT_FRAME:AddMessage("sender: "..sender)
		end
		
		
--!!		-- if Sender is not my realm then return end
		
		local cmd = strsub(message,1,2)
		local arg = strsub(message,3)
		
		if(WHUT_user[WHUT_SERVER][sender]) then
			WHUT_user[WHUT_SERVER][sender]=time()
		end
		
		if (sender==playerName) then
			return
		end
		
		AddUser(sender, WHUT_ONLINE)
		AddUser(sender, WHUT_USER)
		
		if (cmd=="RS") then
			SendServer(sender)
		elseif (cmd=="RO") then
			SendOnline(sender)
		elseif (cmd=="RD") then
			SendData(sender)
		elseif (cmd=="RC") then
			WHUT_user[WHUT_ONLINE][sender]=time()
			SendAddonMessage("WHUT", "O:"..playerName, "WHISPER", sender)
		elseif (cmd=="UL") then
			RemoveUser(sender,WHUT_SERVER)	
			RemoveUser(sender,WHUT_ONLINE)
		elseif (cmd=="S:") then
			if (arg==playerName and actAsServer==false) then
				--i am server now
				BecomeServer()
			elseif (arg~=playerName and not WHUT_user[WHUT_SERVER][arg]) then
				--i know a new server - i assume he is online and a user
				
				--tell the server name to the known servers
				for k,v in pairs(WHUT_user[WHUT_SERVER]) do
					WHUT_user[WHUT_ONLINE][k]=time()
					SendAddonMessage("WHUT", "S:"..arg, "WHISPER", k)
				end
				--add him to all lists
				AddUser(arg,WHUT_SERVER)
				AddUser(arg,WHUT_ONLINE)
				AddUser(arg,WHUT_USER)
				
				--tell him about me
				if (actAsServer) then
					WHUT_user[WHUT_ONLINE][arg]=time()
					SendAddonMessage("WHUT", "S:"..playerName, "WHISPER", arg)
					SendOnline(arg)
					SendServer(arg)
					SendData(arg)
				else
					WHUT_user[WHUT_ONLINE][arg]=time()
					SendAddonMessage("WHUT", "O:"..playerName, "WHISPER", arg)
				end
			end
		elseif (cmd=="O:") then
			if (arg==playerName) then return end
			AddUser(arg,WHUT_ONLINE)
			AddUser(arg,WHUT_USER)
		elseif (cmd=="Q:") then
			AddData(arg)
		end
	elseif(event=="RAID_ROSTER_UPDATE" or event=="PARTY_MEMBERS_CHANGED") then
		raidUpdate=time()
	elseif(event=="PLAYER_ENTERING_WORLD") then
		SaveData()
		onlineSince=time()
	elseif(event=="PLAYER_LEAVING_WORLD") then
		SaveData()
		if (actAsServer==true) then
			for k,v in pairs(WHUT_user[WHUT_ONLINE]) do
				WHUT_user[WHUT_ONLINE][k]=time()
				SendAddonMessage("WHUT", "UL", "WHISPER", k)
			end
		end
	elseif(event=="VARIABLES_LOADED") then
		if(not WHUT_save[GetRealmName()]) then
			WHUT_save[GetRealmName()]={}
		end
		if(type(WHUT_save[GetRealmName()][WHUT_USER]) ~= "table") then
			WHUT_save[GetRealmName()][WHUT_USER]={}
		end
		if(type(WHUT_save[GetRealmName()][WHUT_QUEST]) ~= "table") then
			WHUT_save[GetRealmName()][WHUT_QUEST]={}
		end
		WHUT_user[WHUT_USER]=WHUT_save[GetRealmName()][WHUT_USER]
		WHUT_data[WHUT_QUEST]=WHUT_save[GetRealmName()][WHUT_QUEST]
	elseif(event=="QUEST_ACCEPTED") then
		local questTitle, _,_,_,_,_,_,isDaily,questID = GetQuestLogTitle(...)
		DEFAULT_CHAT_FRAME:AddMessage("QuestAccepted: "..questID)
		--if(isDaily) then
			AddData(questID)
		--end
	elseif(event=="GOSSIP_SHOW") then
		--DEFAULT_CHAT_FRAME:AddMessage("QuestGreeting")
		local questinfo = GetGossipAvailableQuests()
		while(questinfo~=nil) do
			local title,_,_,isDaily,_,_,rest = questinfo
			questinfo=rest
			--DEFAULT_CHAT_FRAME:AddMessage(title..": "..tostring(isDaily))
			for k,v in pairs(Q) do
				if (v==title) then
					AddData(k)
				end
			end
		end
	elseif(event=="QUEST_DETAIL") then
		--DEFAULT_CHAT_FRAME:AddMessage("QuestDetail")
		local title = GetTitleText()
		--DEFAULT_CHAT_FRAME:AddMessage(title..": "..tostring(isDaily))
		for k,v in pairs(Q) do
			if (v==title) then
				AddData(k)
			end
		end
	end
end

local function WHUT_OnUpdate(self, elapsed)
timeSinceLastUpdate = timeSinceLastUpdate + elapsed; 	
timeSinceLastSync = timeSinceLastSync + elapsed; 

if (timeSinceLastUpdate > WHUT_UpdateInterval) then
 
	--wait 10 sec after a Raid/Group-Update, then ask for Serverlist
	if (raidUpdate>0 and raidUpdate+10<time()) then
		if(WHUT_DEBUG["Roster"]) then DEFAULT_CHAT_FRAME:AddMessage("unbehandelte Gruppenänderung vor mehr als 10 Sekunden - Frage Serverliste ab") end
		SendAddonMessage("WHUT", "RS", "RAID")
		raidUpdate=0
	end

	--wait 30 sec after becoming a server for other servers to share Data/Lists, then tell everyone you are server
	if (serverUpdate>0 and serverUpdate+30<time()) then
		if(WHUT_DEBUG["Roster"]) then DEFAULT_CHAT_FRAME:AddMessage("wurde zum Server vor mehr als 30 Sekunden - gebe bekannt!") end
		for k,v in pairs(WHUT_user[WHUT_ONLINE]) do
			WHUT_user[WHUT_ONLINE][k]=time()
			SendAddonMessage("WHUT", "S:"..playerName, "WHISPER", k)
		end
		serverUpdate=0
	end
	
	--try to get a Server-List, 10 sec after going online
	if (time()>onlineSince+10 and init==false) then
		SendAddonMessage("WHUT", "RS", "GUILD")
		for k,v in pairs(WHUT_user[WHUT_USER]) do
			WHUT_user[WHUT_ONLINE][k]=time()
			--DEFAULT_CHAT_FRAME:AddMessage("Send Initial Whisper to "..k)
			SendAddonMessage("WHUT", "RS", "WHISPER", k)
		end
		init=true
	end
	
	--wait 60 sec after going online, if no server found then, become one
	if (onlineSince>0 and onlineSince+60<time()) then
		if (SizeOf(WHUT_user[WHUT_SERVER])==0 and actAsServer==false) then
			if(WHUT_DEBUG["Roster"]) then DEFAULT_CHAT_FRAME:AddMessage("60 sec online und "..NumberOf(WHUT_SERVER).." Server bekannt - dann mach ichs selbst") end
			BecomeServer()
		end
		--onlineSince=0
	end
	
	if (SizeOf(WHUT_user[WHUT_SERVER])<numberOfServers and actAsServer==true) then
		for k,v in pairs(WHUT_user[WHUT_ONLINE]) do
			if (not WHUT_user[WHUT_SERVER][k]) then
				WHUT_user[WHUT_ONLINE][k]=time()
				SendAddonMessage("WHUT", "S:"..k, "WHISPER", k)
				break
			end
		end
	end
	
	CheckValid()
	if (not frame.data.collapsed) then
		ExpandQuestGroup(frame.data)
	end
	UpdateGui()
	
    timeSinceLastUpdate = 0;
end
  
if (timeSinceLastSync > WHUT_SyncInterval) then
	if(actAsServer) then
		--Synchronize Lists
		for k,v in pairs(WHUT_user[WHUT_SERVER]) do
			WHUT_user[WHUT_ONLINE][k]=time()
			SendAddonMessage("WHUT", "RS", "WHISPER", k)
			SendAddonMessage("WHUT", "RO", "WHISPER", k)
			SendAddonMessage("WHUT", "RD", "WHISPER", k)
		end
	end
	
	for k,v in pairs(WHUT_user[WHUT_ONLINE]) do
		WHUT_user[WHUT_ONLINE][k]=nil
		SendAddonMessage("WHUT", "RC", "WHISPER", k)
	end
	timeSinceLastSync = 0
end
  
end

frame:SetScript("OnEvent", WHUT_OnEvent)
frame:SetScript("OnUpdate", WHUT_OnUpdate)
ChatFrame_AddMessageEventFilter("CHAT_MSG_SYSTEM", filterOfflineMessages)

